#include "iic.h"


//------------------------------------------------------------





//------------------------------------------------------------

#ifdef Hardware_IIC
/**
 * @name IIC_config
 * @brief ӲIIC
 * @version 汾v1.0
 * @date ڣ2024-3-23
 * @author ߣ
 * @note עͣ
 */
void IIC_Hardware_config()
{
    I2C_InitTypeDef I2C_InitStructure;

    // 
    I2C_InitStructure.I2C_Mode      = I2C_Mode_Master;	    //ѡ   I2C_Mode_Master, I2C_Mode_Slave
	I2C_InitStructure.I2C_Enable    = ENABLE;			    //I2Cʹ,   ENABLE, DISABLE
	I2C_InitStructure.I2C_MS_WDTA   = DISABLE;			    //ʹԶ,  ENABLE, DISABLE
	I2C_InitStructure.I2C_Speed     = 63;				    //ٶ=Fosc/2/(Speed*2+4),      0~63
	I2C_Init(&I2C_InitStructure);
	NVIC_I2C_Init(I2C_Mode_Master,DISABLE,Priority_0);		//ģʽ, I2C_Mode_Master, I2C_Mode_Slave; жʹ, ENABLE/DISABLE; ȼ(͵) Priority_0,Priority_1,Priority_2,Priority_3

    // ӻ
    // I2C_InitStructure.I2C_Mode      = I2C_Mode_Slave;		//ѡ   I2C_Mode_Master, I2C_Mode_Slave
	// I2C_InitStructure.I2C_Enable    = ENABLE;				//I2Cʹ,   ENABLE, DISABLE
	// I2C_InitStructure.I2C_SL_MA     = ENABLE;				//ʹܴӻַȽϹ,   ENABLE, DISABLE
	// I2C_InitStructure.I2C_SL_ADR    = 0x2d;					//ӻ豸ַ,  0~127  (0x2d<<1 = 0x5a)
	// I2C_Init(&I2C_InitStructure);
	// NVIC_I2C_Init(I2C_Mode_Slave,I2C_ESTAI|I2C_ERXI|I2C_ETXI|I2C_ESTOI,Priority_0);	//ģʽ, I2C_Mode_Master, I2C_Mode_Slave; жʹ, I2C_ESTAI/I2C_ERXI/I2C_ETXI/I2C_ESTOI/DISABLE; ȼ(͵) Priority_0,Priority_1,Priority_2,Priority_3

	I2C_SW(I2C_P24_P25);					//I2C_P14_P15,I2C_P24_P25,I2C_P76_P77,I2C_P33_P32

}

/**
 * @name Wait
 * @brief ȴģʽI2CִI2CMSCR
 * @version 汾v1.0
 * @date ڣ2024
 * @author ߣ
 * @note עͣ
 */
void Wait(void)
{
	while (!(I2CMSST & 0x40));
	I2CMSST &= ~0x40;
}

/**
 * @name IIC_Start
 * @brief I2Cʼ
 * @version 汾v1.0
 * @date ڣ2024
 * @author ߣ
 * @note עͣ
 */
void Start(void)
{
	I2CMSCR = 0x01;                         //START
	Wait();
}    

/**
 * @name IIC_Stop
 * @brief I2Cֹͣ
 * @version 汾v1.0
 * @date ڣ2024
 * @author ߣ
 * @note עͣ
 */
void Stop(void)
{
	I2CMSCR = 0x06;                         //STOP
	Wait();
}

/**
 * @name IIC_SendACK
 * @brief ACK
 * @version 汾v1.0
 * @date ڣ2024
 * @author ߣ
 * @note עͣSend ACK (LOW)
 */
void SendACK(void)
{
	I2CMSST = 0x00;                         //ACKź
	I2CMSCR = 0x05;                         //ACK
	Wait();
}

/**
 * @name IIC_SendNoACK
 * @brief NoACK
 * @version 汾v1.0
 * @date ڣ2024
 * @author ߣ
 * @note עͣSend No ACK (High)
 */
void SendNAK(void)
{
	I2CMSST = 0x01;                         //NAKź
	I2CMSCR = 0x05;                         //ACK
	Wait();
}

/**
 * @name IIC_Check_ACK
 * @brief ȴ()ACK
 * @version 汾v1.0
 * @date ڣ2024
 * @author ߣ
 * @note עͣCheck ACK, If F0=0, then right, if F0=1, then error
 */
void RecvACK(void)
{
	I2CMSCR = 0x03;                         //ͶACK
	Wait();
}

/**
 * @name IIC_WriteAbyte
 * @brief һֽ
 * @param dat
 * @version 汾v1.0
 * @date ڣ2024
 * @author ߣ
 * @note עͣwrite a byte to I2C
 */
void SendData(u8 dat)
{
	I2CTXD = dat;                           //дݵݻ
	I2CMSCR = 0x02;                         //SEND
	Wait();
}

/**
 * @name IIC_ReadAbyte
 * @brief ȡһֽ
 * @return dat
 * @version 汾v1.0
 * @date ڣ2024
 * @author ߣ
 * @note עͣread A byte from I2C
 */
char RecvData(void)
{
	I2CMSCR = 0x04;                         //RECV
	Wait();
	return I2CRXD;
}

//---------------------ܺ---------------------

/**
 * @name IIC_WriteNbyte
 * @brief IICдļֽ
 * @param slave: ѡһӻĵַ
 * @param mem_addr: ݵĵַ
 * @param p: ݣдݴ洢λ
 * @param number: д뼸
 * @return 
 * @version 汾v1.0
 * @date ڣ2024-3-23
 * @author ߣϫ
 * @note עͣDeviceAddress,WordAddress,First Data Address,Byte lenth
 */
void IIC_WriteNbyte_Hard(u8 slave, u8 mem_addr, u8 *p, u8 number)
{
	Start();                                //ʼ
	SendData(slave);                     //豸ַ+д
	RecvACK();
	SendData(mem_addr);                     //ʹ洢ַ
	RecvACK();
	do
	{
		SendData(*p++);
		RecvACK();
	}
	while(--number);
	Stop();   
}

/**
 * @name IIC_ReadNbyte
 * @brief IICȡļֽ
 * @param slave: ѡһӻĵַ
 * @param mem_addr: Ҫݵĵַ
 * @param p: ݣȡݴ洢λ
 * @param number: д뼸
 * @return 
 * @version 汾v1.0
 * @date ڣ2024-3-23
 * @author ߣϫ
 * @note עͣͿʼ->ַд->ݵַ->Ϳʼ->ַ->
 * DeviceAddress,WordAddress,First Data Address,Byte lenth
 */
void IIC_ReadNbyte_Hard(u8 slave, u8 mem_addr, u8 *p, u8 number)
{
	Start();                                //ʼ
	SendData(slave);                     //豸ַ+д
	RecvACK();
	SendData(mem_addr);                     //ʹ洢ַ
	RecvACK();
	Start();                                //ʼ
	SendData(slave|1);                   //豸ַ+
	RecvACK();
	do
	{
		*p = RecvData();
		p++;
		if(number != 1) SendACK();          //send ACK
	}
	while(--number);
	SendNAK();                              //send no ACK	
	Stop();                                 //ֹͣ
}

#endif

#ifdef Software_IIC

/**
 * @name IIC_Software_config
 * @brief IIC
 * @version 汾v1.0
 * @date ڣ2024
 * @author ߣ
 * @note עͣ
 */
void IIC_Software_config()
{
	#if     IIC_PIN == 0        //4P
    SCL = 1;
    SDA = 1;
    #elif   IIC_PIN == 1        //7P
    SCL = 1;
    SDA = 1;
    RES = 1;
    DC = 0;
    CS = 0;
    #endif
}

/**
 * @name IIC_Delay2us
 * @brief IICӳ2΢
 * @version 汾v1.0
 * @date ڣ2024
 * @author ߣ
 * @note עͣfor normal MCS51, delay (2 * dly + 4) T, for STC12Cxxxx delay (4 * dly + 10) T
 */
void IIC_Delay2us(void)
{
	u8  dly;
	dly = MAIN_Fosc / 2000000UL;        //2us
	while(--dly);
}

/**
 * @name IIC_Start
 * @brief IIC
 * @version 汾v1.0
 * @date ڣ2024
 * @author ߣ
 * @note עͣstart the I2C, SDA High-to-low when SCL is high
 */
void IIC_Start(void)
{
	SDA = 1;
	IIC_Delay2us();
	SCL = 1;
	IIC_Delay2us();
	SDA = 0;
	IIC_Delay2us();
	SCL = 0;
	IIC_Delay2us();
}    

/**
 * @name IIC_Stop
 * @brief IIC
 * @version 汾v1.0
 * @date ڣ2024
 * @author ߣ
 * @note עͣSTOP the I2C, SDA Low-to-high when SCL is high
 */
void IIC_Stop(void)
{
	SDA = 0;
	IIC_Delay2us();
	SCL = 1;
	IIC_Delay2us();
	SDA = 1;
	IIC_Delay2us();
}

/**
 * @name IIC_SendACK
 * @brief ACK
 * @version 汾v1.0
 * @date ڣ2024
 * @author ߣ
 * @note עͣSend ACK (LOW)
 */
void IIC_SendACK(void)
{
	SDA = 0;
	IIC_Delay2us();
	SCL = 1;
	IIC_Delay2us();
	SCL = 0;
	IIC_Delay2us();
}

/**
 * @name IIC_SendNoACK
 * @brief NoACK
 * @version 汾v1.0
 * @date ڣ2024
 * @author ߣ
 * @note עͣSend No ACK (High)
 */
void IIC_SendNoACK(void)
{
	SDA = 1;
	IIC_Delay2us();
	SCL = 1;
	IIC_Delay2us();
	SCL = 0;
	IIC_Delay2us();
}

/**
 * @name IIC_Check_ACK
 * @brief ȴ()ACK
 * @version 汾v1.0
 * @date ڣ2024
 * @author ߣ
 * @note עͣCheck ACK, If F0=0, then right, if F0=1, then error
 */
void IIC_Check_ACK(void)
{
	SDA = 1;
	IIC_Delay2us();
	SCL = 1;
	IIC_Delay2us();
	F0  = SDA;
	SCL = 0;
	IIC_Delay2us();
}

/**
 * @name IIC_WriteAbyte
 * @brief һֽ
 * @param dat
 * @version 汾v1.0
 * @date ڣ2024
 * @author ߣ
 * @note עͣwrite a byte to I2C
 */
void IIC_WriteAbyte(u8 dat)
{
	u8 i;
	i = 8;
	do
	{
		if(dat & 0x80)  SDA = 1;
		else            SDA = 0;
		dat <<= 1;
		IIC_Delay2us();
		SCL = 1;
		IIC_Delay2us();
		SCL = 0;
		IIC_Delay2us();
	}
	while(--i);
}

/**
 * @name IIC_ReadAbyte
 * @brief ȡһֽ
 * @return dat
 * @version 汾v1.0
 * @date ڣ2024
 * @author ߣ
 * @note עͣread A byte from I2C
 */
u8 IIC_ReadAbyte(void)
{
	u8 i,dat;
	i = 8;
	SDA = 1;
	do
	{
		SCL = 1;
		IIC_Delay2us();
		dat <<= 1;
		if(SDA)     dat++;
		SCL  = 0;
		IIC_Delay2us();
	}
	while(--i);
	return(dat);
}

//---------------------ܺ---------------------

/**
 * @name IIC_WriteNbyte
 * @brief IICдļֽ
 * @param slave: ѡһӻĵַ
 * @param mem_addr: ݵĵַ
 * @param p: ݣдݴ洢λ
 * @param number: д뼸
 * @return 
 * @version 汾v1.0
 * @date ڣ2024-3-23
 * @author ߣϫ
 * @note עͣ
 */
void IIC_WriteNbyte_Soft(u8 slave, u8 mem_addr, u8 *p, u8 number)  /*  DeviceAddress,WordAddress,First Data Address,Byte lenth  */
{
	IIC_Start();
	IIC_WriteAbyte(slave);
	IIC_Check_ACK();
	if(!F0)                                           //F0=0,right, F0=1,error
	{
		IIC_WriteAbyte(mem_addr);
		IIC_Check_ACK();
		if(!F0)
		{
			do
			{
				IIC_WriteAbyte(*p); p++;
				IIC_Check_ACK();
				if(F0)  break;
			}
			while(--number);
		}
	}
	IIC_Stop();
}

/**
 * @name IIC_ReadNbyte
 * @brief IICȡļֽ
 * @param slave: ѡһӻĵַ
 * @param mem_addr: Ҫݵĵַ
 * @param p: ݣȡݴ洢λ
 * @param number: д뼸
 * @return 
 * @version 汾v1.0
 * @date ڣ2024-3-23
 * @author ߣϫ
 * @note עͣͿʼ->ַд->ݵַ->Ϳʼ->ַ->
 */
void IIC_ReadNbyte_Soft(u8 slave, u8 mem_addr, u8 *p, u8 number)  /*  DeviceAddress,WordAddress,First Data Address,Byte lenth  */
{
	IIC_Start();
	IIC_WriteAbyte(slave);
	IIC_Check_ACK();
	if(!F0)
	{
		IIC_WriteAbyte(mem_addr);
		IIC_Check_ACK();
		if(!F0)
		{
			IIC_Start();
			IIC_WriteAbyte(slave|1);
			IIC_Check_ACK();
			if(!F0)
			{
				do
				{
					*p = IIC_ReadAbyte();   p++;
					if(number != 1)     IIC_SendACK();    //send ACK
				}
				while(--number);
				IIC_SendNoACK();          //send no ACK
			}
		}
	}
	IIC_Stop();
}
#endif

