#include "spi.h"


//------------------------------------------------------------





//------------------------------------------------------------

#ifdef Hardware_SPI         //1ӲSPI

void SPI_Hardware_config()
{
    SPI_InitTypeDef		SPI_InitStructure;
	SPI_InitStructure.SPI_Enable    = ENABLE;				//SPI    ENABLE, DISABLE
	SPI_InitStructure.SPI_SSIG      = ENABLE;				//Ƭѡλ     ENABLE, DISABLE
	SPI_InitStructure.SPI_FirstBit  = SPI_MSB;				//λ   SPI_MSB, SPI_LSB
	SPI_InitStructure.SPI_Mode      = SPI_Mode_Master;		//ѡ   SPI_Mode_Master, SPI_Mode_Slave
	SPI_InitStructure.SPI_CPOL      = SPI_CPOL_High;			//ʱλ   SPI_CPOL_High,   SPI_CPOL_Low
	SPI_InitStructure.SPI_CPHA      = SPI_CPHA_2Edge;		//ݱ   SPI_CPHA_1Edge,  SPI_CPHA_2Edge
	SPI_InitStructure.SPI_Speed     = SPI_Speed_4;			//SPIٶ    SPI_Speed_4, SPI_Speed_8, SPI_Speed_16, SPI_Speed_2
	SPI_Init(&SPI_InitStructure);
	NVIC_SPI_Init(DISABLE,Priority_0);		//жʹ, ENABLE/DISABLE; ȼ(͵) Priority_0,Priority_1,Priority_2,Priority_3
	SPI_ClearFlag();   // SPIFWCOL ־
	SPI_SW(SPI_P22_P23_P24_P25);	//SPI_P54_P13_P14_P15,SPI_P22_P23_P24_P25,SPI_P54_P40_P41_P43,SPI_P35_P34_P33_P32

    // SPI(HSSPI)
    HSPllClkConfig(MCLKSEL_HIRC,PLL_96M,4);    //ϵͳʱѡ,PLLʱѡ,ʱӷƵϵ
	HSSPI_Enable();

    // ʼһ
    SPI_SCLK_2 = 0;     // SPIӿڳʼƽ SCLK_D0
    SPI_MOSI_2 = 1;     // MOSI_D1
    SPI_SS_2 = 1;       // CS
}

/**
 * @name SPI_WriteByte_Hard
 * @brief SPIһֽ
 * @param dat: Ҫ͵
 * @version 汾v1.0
 * @date ڣ2024
 * @author ߣ
 * @note עͣ
 */
void SPI_WriteByte_Hard(u8 dat)		//SPIһֽ
{
	if(ESPI)
	{
		B_SPI_Busy = 1;
		SPDAT = dat;
		while(B_SPI_Busy);  //жģʽ
	}
	else
	{
		SPDAT = dat;
		while(SPIF == 0);   //ѯģʽ
		SPI_ClearFlag();    //SPIFWCOL־
	}
}

/**
 * @name SPI_ReadByte_Hard
 * @brief SPIѯģʽȡһֽ
 * @return ȡ
 * @version 汾v1.0
 * @date ڣ2024
 * @author ߣ
 * @note עͣ
 */
u8 SPI_ReadByte_Hard(void)
{
	SPDAT = 0xff;
	while(SPIF == 0) ;
	SPI_ClearFlag();   //0 SPIFWCOL־
	return (SPDAT);
}
#endif

#ifdef Software_SPI         // 0ģSPI

void SPI_Software_config(void)             //ʼ
{
    // CS   = 1;               //1ѡ
    // MISO = 1;               //
    // WP   = 1;               //
    MOSI_D1 = 1;               //
    SCLK_D0 = 0;               //spiģʽ0SCLKʼΪ͵ƽ
}

void SPI_WirteByte_Soft(u8 dat)      //дһֽ
{
    u8 i;
    for ( i = 0; i < 8; i++)
    {
        if (dat & 0x80)
            MOSI_D1 = 1;
        else
            MOSI_D1 = 0;
        // SCLK_D0 = 1;               //һ½
        // SCLK_D0 = 0;               
        SCLK_D0 = 0;               //һ
        SCLK_D0 = 1; 
        dat <<= 1;
    }
}

u8 SPI_ReadByte_Soft(void)          //ȡһֽ
{
    u8 i;
    u8 dat=0;
    for ( i = 0; i < 8; i++)
    {
        dat <<= 1;
        // SCLK_D0 = 0;               //һ
        SCLK_D0 = 1;               //һ
        if (MISO)               //ӻݵ
            dat |= 1;
        else
            dat |= 0;
        SCLK_D0 = 0;
    }
    return dat;
}

#endif

#ifdef Uartware_SPI         // 2USART_SPI

void SPI_Uartware_config(void)             //ʼ
{
    P_SW3 &= 0XF3;          //ѡ
    P_SW3 |= 0X04;          //01SS:P22 MOSI:P23 MISO:24 SCLK:P25

    SCON = 0x10;            //ģʽѡ
    USARTCR1 = 0x10;        //1ͬģʽƼĴ1
    USARTCR1 |= 0x08;
    USARTCR4 = 0x00;        //1ͬģʽƼĴ4
}

void SPI_WirteByte_Uart(u8 dat)      //дһֽ
{
    TI = 0;
    SBUF = dat;
    while(!TI);
}

u8 SPI_ReadByte_Uart(void)          //ȡһֽ
{
    TI = 0;
    SBUF = 0x00;        //ݣ8壬ʱź
    while(!TI);
    return SBUF;
}

#endif

